$TITLE(I2C_Write_Com_Write command)
;*==========================================================*
;*                                                          *
;*         SOURCE FILE : I2C_WCOW.ASM                       *
;*         PACKAGE     : I2C                                *
;*                                                          *
;*==========================================================*
$DEBUG


;*==========================================================*
;*    I N C L U D E S                                       *
;*==========================================================*
$NOLIST
$INCLUDE(I2C_DATA.GLO)
$LIST


;*==========================================================*
;*    G L O B A L   R E F E R E N C E S                     *
;*==========================================================*
    EXTRN CODE(I2C_MESS_HAND)


;*==========================================================*
;*    G L O B A L   F U N C T I O N   D E F I N I T I O N S *
;*==========================================================*
    PUBLIC _I2C_WRITE_COM_WRITE


;*==========================================================*
;*    L O C A L   S Y M B O L   D E C L A R A T I O N S     *
;*==========================================================*
   WRITE_COM_WRITE_MASK  EQU 10H
                    ;REP_STRT_BLK1  = 0    (NO)
                    ;RWN_BLK1       = 0    (WRITE)
                    ;ADDR2          = 0    (NO)
                    ;ADDR2_SUB      = 0    (--)
                    ;BLOCK2         = 1    (YES)
                    ;RWN_BLK2       = 0    (WRITE)
                    ;REP_STRT_BLK2  = 0    (--)
                    ;T_DEVICE       = 0    (NO)


;*==========================================================*
;*    C O D E   S E G M E N T                               *
;*==========================================================*
    I2C_DRIVER SEGMENT CODE
    RSEG I2C_DRIVER


;*MPF:::I2C::I2C_WCOW.ASM:I2C_WRITE_COM_WRITE===============*
;*                                                          *
;* FUNCTION NAME:      I2C_WRITE_COM_WRITE                  *
;* PACKAGE:            I2C                                  *
;* DESCRIPTION:                                             *
;*   Write a 2 blocks of data (a,b length n,m) in a single  *
;*   message to a slave device                              *
;*                                                          *
;* PROTOCOL:                                                *
;*   <S><SLV_ADDR1><W><A><Da0><A><Da1<A>..<A><Dan-1><A>     *
;*                       <Db0><A><Db1<A>..<A><Dbm-1><A><P>  *
;*                                                          *
;* INPUT: Message control byte I2C_CTRL (bit addressable)   *
;*        Message control block I2C_MCB, containing:        *
;*          I2C_ADDR1       (slave address first device)    *
;*          BUF_LEN1        (number of bytes in block a)    *
;*          BUF_PTR1        (ptr to block a)                *
;*          BUF_LEN1        (number of bytes in block b)    *
;*          BUF_PTR1        (ptr to block b)                *
;*                                                          *
;* OUTPUT: I2C_ERROR byte  (bit addressable)                *
;*                                                          *
;*EMP=======================================================*

_I2C_WRITE_COM_WRITE:
        MOV     I2C_MCB+5,I2C_MCB+4
        MOV     I2C_MCB+4,I2C_MCB+3
        MOV     I2C_CTRL,#WRITE_COM_WRITE_MASK
        AJMP    I2C_MESS_HAND

        END
