$TITLE(I2C_Write_Rep_Write command)
;*==========================================================*
;*                                                          *
;*         SOURCE FILE : I2C_WREW.ASM                       *
;*         PACKAGE     : I2C                                *
;*                                                          *
;*==========================================================*
$DEBUG


;*==========================================================*
;*    I N C L U D E S                                       *
;*==========================================================*
$NOLIST
$INCLUDE(I2C_DATA.GLO)
$LIST


;*==========================================================*
;*    G L O B A L   R E F E R E N C E S                     *
;*==========================================================*
    EXTRN CODE(I2C_MESS_HAND)


;*==========================================================*
;*    G L O B A L   F U N C T I O N   D E F I N I T I O N S *
;*==========================================================*
    PUBLIC _I2C_WRITE_REP_WRITE


;*==========================================================*
;*    L O C A L   S Y M B O L   D E C L A R A T I O N S     *
;*==========================================================*
   WRITE_REP_WRITE_MASK  EQU 54H
                    ;REP_STRT_BLK1  = 0    (NO)
                    ;RWN_BLK1       = 0    (WRITE)
                    ;ADDR2          = 1    (YES)
                    ;ADDR2_SUB      = 0    (NO)
                    ;BLOCK2         = 1    (YES)
                    ;RWN_BLK2       = 0    (WRITE)
                    ;REP_STRT_BLK2  = 1    (YES)
                    ;TEST_DEVICE    = 0    (--)


;*==========================================================*
;*    C O D E   S E G M E N T                               *
;*==========================================================*
    I2C_DRIVER SEGMENT CODE
    RSEG I2C_DRIVER


;*MPF:::I2C::I2C_WRER.ASM:I2C_WRITE_REP_WRITE===============*
;*                                                          *
;* FUNCTION NAME:      I2C_WRITE_REP_WRITE                  *
;* PACKAGE:            I2C                                  *
;* DESCRIPTION:                                             *
;*   Write a block of data (a length n) to a slave device,  *
;*   sent repeated start and write a block (b length m) to  *                               *
;*   another slave device.                                  *
;*                                                          *
;* PROTOCOL:                                                *
;*   <S><SLV_ADDR1><W><A><Da0><A><Da1<A>..<A><Dan-1><A>     *
;*   <S><SLV_ADDR2><W><A><Db0><A><Db1<A>..<A><Dbm-1><A><P>  *
;*                                                          *
;* INPUT: Message control byte I2C_CTRL (bit addressable)   *
;*        Message control block I2C_MCB, containing:        *
;*          I2C_ADDR1       (slave address first device)    *
;*          BUF_LEN1        (number of bytes in block a)    *
;*          BUF_PTR1        (ptr to block a)                *
;*          I2C_ADDR2       (slave address second device)   *
;*          BUF_LEN1        (number of bytes in block b)    *
;*          BUF_PTR1        (ptr to block b)                *
;*                                                          *
;* OUTPUT: I2C_ERROR byte  (bit addressable)                *
;*                                                          *
;*EMP=======================================================*

_I2C_WRITE_REP_WRITE:
        MOV     I2C_CTRL,#WRITE_REP_WRITE_MASK
        AJMP    I2C_MESS_HAND

        END
