$TITLE(I2C_Write_Sub command)
;*==========================================================*
;*                                                          *
;*         SOURCE FILE : I2C_WSUB.ASM                       *
;*         PACKAGE     : I2C                                *
;*                                                          *
;*==========================================================*
$DEBUG


;*==========================================================*
;*    I N C L U D E S                                       *
;*==========================================================*
$NOLIST
$INCLUDE(I2C_DATA.GLO)
$LIST


;*==========================================================*
;*    G L O B A L   R E F E R E N C E S                     *
;*==========================================================*
    EXTRN CODE(I2C_MESS_HAND)


;*==========================================================*
;*    G L O B A L   F U N C T I O N   D E F I N I T I O N S *
;*==========================================================*
    PUBLIC _I2C_WRITE_SUB


;*==========================================================*
;*    L O C A L   S Y M B O L   D E C L A R A T I O N S     *
;*==========================================================*
   WRITE_SUB_MASK  EQU 0CH
                    ;REP_STRT_BLK1  = 0    (NO)
                    ;RWN_BLK1       = 0    (WRITE)
                    ;ADDR2          = 1    (YES)
                    ;ADDR2_SUB      = 1    (YES)
                    ;BLOCK2         = 0    (NO)
                    ;RWN_BLK2       = 0    (--)
                    ;REP_STRT_BLK2  = 0    (--)
                    ;TEST_DEVICE    = 0    (--)


;*==========================================================*
;*    C O D E   S E G M E N T                               *
;*==========================================================*
    I2C_DRIVER SEGMENT CODE
    RSEG I2C_DRIVER


;*MPF:::I2C::I2C_WSUB.ASM:I2C_WRITE_SUB=====================*
;*                                                          *
;* FUNCTION NAME:      I2C_WRITE_SUB                        *
;* PACKAGE:            I2C                                  *
;* DESCRIPTION:                                             *
;*   Write a block of data (a length n) preceded by a       *
;*   sub address to a slave device.                         *
;*                                                          *
;* PROTOCOL:                                                *
;*   <S><SLV_ADDR><W><A><SUB_ADDR><A><Da0><A><Da1<A>..<A>   *
;*                                           <Dan-1><A><P>  *
;*                                                          *
;* INPUT: Message control byte I2C_CTRL (bit addressable)   *
;*        Message control block I2C_MCB, containing:        *
;*          I2C_ADDR1       (slave address)                 *
;*          BUF_LEN1        (number of bytes in block )     *
;*          BUF_PTR1        (ptr to block )                 *
;*          I2C_ADDR2       (sub address)                   *
;*                                                          *
;* OUTPUT: I2C_ERROR byte  (bit addressable)                *
;*                                                          *
;*EMP=======================================================*

_I2C_WRITE_SUB:
        MOV     I2C_CTRL,#WRITE_SUB_MASK
        AJMP    I2C_MESS_HAND

        END
