/******************************************************************
  Program do obsugi funkcji interfejsu sprztowego I2C PCF8584.
  Gwna cz drivera obsugi. Na podstawie AN95068 firmy Philips

  Raisonance RC-51
 ******************************************************************/
#include "i2cexprt.h"
#include "i2cdrivr.h"
#include "reg8584.h"

static void NoInitErrorProc(void);

void (*MasterProc)(void) = NoInitErrorProc;
void (*SlaveProc)(void) = NoInitErrorProc;

unsigned char master;
unsigned char intMask;



/* funkcja wywoywana, gdy nie ustawiono procedur obsugi bdw dla trybw master i slave */
static void NoInitErrorProc(void)
{
	CR_8584 = 0xC0 | intMask;					//zwolnienie I2C, Nack
}


/* gwna procedura obsugi zdarze interfejsu I2C */
void MainStateHandler(void)
{
	if (master)
		MasterProc();
	else
		SlaveProc();
}


/* procedura obsugi przerwa generowanych przez kontroler I2C */
void I2C_Interrupt(void) interrupt 0
{
	MainStateHandler();
}


/* wczenie przerwa kontrolera I2C PCF8584, wektor przerwania jest parametrem procedury */
void InstallInterrupt(unsigned char vector)
{
	CR_8584 = 0x10;								//zapis wektora przerwa
	VR_8584 = vector;
	intMask = ENI_MASK;
	CR_8584 = ESO_MASK | ENI_MASK;			//wczenie interfejsu szeregowego I2C
}


