;************************************************************************
;*									*
;*		Read / Write IO Expander PCF8574/A			*
;*									*
;************************************************************************

;**********************	PCF8574/A: Read Byte ****************************
;Input:	R7 = Address
;Output: A = Byte
;	CY = 1: Error, no I2C-device at this address
;Used:	R2

P8574RD:
	call si2csta		;start
	mov a, r7
	call si2cout		;send address
	jc ?p74r1		;Error, NACK received
	setb c			;send NACK (read only 1 byte)
	call si2cin		;read byte
?p74r1:	jmp si2csto		;stop

;**********************	PCF8574/A: Write Byte ***************************
;Input:	R7 = Address
;	A = Byte
;Output: CY = 1: Error, no I2C-device at this address
;Used:	R2

P8574WR:
	call si2csta		;start
	xch a, r7
	call si2cout		;send address
	mov a, r7
	call si2cout		;send byte
	jmp si2csto		;stop
;------------------------------------------------------------------------
